package com.mamezou.sample.webflow.service;

import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import com.mamezou.sample.webflow.entity.Customer;
import com.mamezou.sample.webflow.exception.DataNotFoundException;

public class DefaultCustomerService implements CustomerService {
    
    private Map<Integer, Customer> customerMap
                            = new LinkedHashMap<Integer, Customer>();
    
    private int nextId;
    
    public DefaultCustomerService() {
        nextId = 1;
        
        create(new Customer("Y", "sVh", "03-xxxx-xxx1"));
        create(new Customer("Y", "sL", "03-xxxx-xxx2"));
        create(new Customer("OY", "s", "03-xxxx-xxx3"));
    }

    private boolean isExists(int id) {
        return customerMap.containsKey(id);
    }
    
    public List<Customer> findAll() {
        return new ArrayList<Customer>(customerMap.values());
    }

    public Customer findByPk(int id) throws DataNotFoundException {
        if (!isExists(id)) {
            throw new DataNotFoundException();
        }
        return customerMap.get(id);
    }

    public Customer create(Customer customer) {
        customer.setId(nextId);
        customerMap.put(customer.getId(), customer);
        
        nextId++;
        
        return customer;
    }

    public void update(Customer customer) throws DataNotFoundException {
        if (!isExists(customer.getId())) {
            throw new DataNotFoundException();
        }
        customerMap.put(customer.getId(), customer);
    }

    public void delete(int id) throws DataNotFoundException {
        if (!isExists(id)) {
            throw new DataNotFoundException();
        }
        customerMap.remove(id);
    }

    public boolean isOverseasCustomer(Customer customer) {
        // ̎ł́A
        // Customer#isOverseasĂяoāA
        // ̌ʂԂ
        return customer.isOverseas();
    }
    
    public void out(String obj) {
        System.out.println("Out called : [" + obj + "]");
    }
}
