package com.mamezou.sample.webflow.web.create;

import org.springframework.webflow.action.MultiAction;
import org.springframework.webflow.core.collection.ParameterMap;
import org.springframework.webflow.execution.Event;
import org.springframework.webflow.execution.RequestContext;

import com.mamezou.sample.webflow.entity.Customer;

public class EnterNewCustomerAction extends MultiAction {

    public Event setupForm(RequestContext ctx) {
        if (ctx.getFlowScope().get("customer") != null) {
            return success();
        }
        
        Customer customer = new Customer();
        ctx.getFlowScope().put("customer", customer);
        return success();
    }
    
    public Event bindAndValidate(RequestContext ctx) {
        Customer customer
                = (Customer) ctx.getFlowScope().get("customer");

        ParameterMap param = ctx.getRequestParameters();
        
        customer.setName(param.get("name"));
        customer.setAddress(param.get("address"));
        customer.setTelNo(param.get("telNo"));
        
        return success();
    }
}
